#include <assert.h>
#include <stdlib.h>

#include "new.h"
#include "new.r"

void * new (void * _class, ...)
{	
    struct Class * class = _class;
    // Where is class->size assigned a value? At the bottom of Person.c
	void * p = calloc(1, class->size);

	assert(p);
	// p points to a block of memory. The following
	// statement sets that block to point back
	// to this class (actually, the start of the block
	// points back to this class, the remainder of the
	// block is filled in with class-specific data)
	* (struct Class **) p = class;

	if (class->ctor)
	{	va_list ap;

		va_start(ap, _class);
		// Set p to point to the result
		// of calling the ctor function
		// (constructor function)
		p = class->ctor(p, & ap);
		va_end(ap);
	}
	return p;
}

void delete (void * self)
{	
    struct Class ** cp = self;

	if (self && * cp && (* cp) -> dtor)
		self = (* cp) -> dtor(self);
	free(self);
}

void * clone (void * self)
{	
    struct Class ** cp = self;

	assert(self && * cp && (* cp) -> clone);
	return (* cp) -> clone(self);
}

char * toString (void * self)
{	
    struct Class ** cp = self;

	assert(self && * cp && (* cp) -> toString);
	return (* cp) -> toString(self);
}